# -*- coding: utf-8 -*-

from datetime import datetime, timedelta
from dateutil.rrule import *
from dateutil.parser import *
from dateutil.easter import *
from PyQt4 import QtGui
rel_matrix = [+1,+2,+3,+4,-1]
black = QtGui.QColor(0,0,0)
grey = QtGui.QColor(100,100,100)

def deltaDays(early,late,fixed_rules,variable_rules,variable_ext,gf,em,grange,dialog,working=0,inclusive_start=0,inclusive_end=0):
    print "inc_start:"
    print inclusive_start
    print "inc_end"
    print inclusive_end
    print "variable rules:"
    print variable_rules
    print "variable ext rules:"
    print variable_ext
    print "good friday:"
    print gf
    print "easter monday:"
    print em
    print "fixed rules:"
    print fixed_rules
    print "range rules:"
    print grange
    dialog.textEdit.clear()
    wkg_count = 0
    if working == 1:
        if inclusive_start == 0:
            early = early + timedelta(days=1)
        while 1:
            flag = 0
            dialog.textEdit.setTextColor(grey)
            dialog.textEdit.append("Working On: " + str(early).split()[0])
            if len(rrule(DAILY,byweekday=(SA,SU),dtstart=early).between(early,early,True)) == 1:
                flag = 1
                dialog.textEdit.setTextColor(black)
                dialog.textEdit.append(str(early).split()[0] + " is on a weekend")
            if (len(fixed_rules) > 0) and (flag == 0):
                for i in fixed_rules:
                    if len(rrule(YEARLY,bymonth=i[1],bymonthday=i[0],byweekday=(MO,TU,WE,TH,FR),dtstart=early).between(early,early,True)) == 1:
                        flag = 1
                        dialog.textEdit.setTextColor(black)
                        dialog.textEdit.append(str(early).split()[0] + " is a fixed date holiday")
                        break
            if len(variable_rules) > 0 and (flag == 0):
                for i in variable_rules:
                    if len(rrule(YEARLY,bymonth=i[2],byweekday=i[1](rel_matrix[i[0]-1]),dtstart=early).between(early,early,True)) == 1:
                        flag = 1
                        dialog.textEdit.setTextColor(black)
                        dialog.textEdit.append(str(early).split()[0] + " is a variable date holiday")
                        break
            if len(variable_ext) > 0 and (flag == 0):
                for i in variable_ext:
                    if len(rrule(YEARLY,byyearday=(i[1][0],i[1][1],i[1][2],i[1][3],i[1][4],i[1][5],i[1][6]),byweekday=i[0],dtstart=early).between(early,early,True)) == 1:
                        flag = 1
                        dialog.textEdit.setTextColor(black)
                        dialog.textEdit.append(str(early).split()[0] + " is a variable date holiday")
                        break
            if gf == 1 and (flag == 0):
                tempdate = str(early)
                currentyear = int(tempdate.split('-')[0])
                if tempdate.split()[0] == str(easter(currentyear) + timedelta(days=-2)):
                    flag = 1
                    dialog.textEdit.setTextColor(black)
                    dialog.textEdit.append(str(early).split()[0] + " is good friday")
            if em == 1 and (flag == 0):
                tempdate = str(early)
                currentyear = int(tempdate.split('-')[0])
                if tempdate.split()[0] == str(easter(currentyear) + timedelta(days=1)):
                    flag = 1
                    dialog.textEdit.setTextColor(black)
                    dialog.textEdit.append(str(early).split()[0] + " is easter monday")
            if len(grange) > 0 and (flag == 0):
                for i in grange:
                    if len(rrule(YEARLY,bymonth=i[1],bymonthday=i[0],byweekday=(MO,TU,WE,TH,FR),dtstart=early).between(early,early,True)) == 1:
                        flag = 1
                        dialog.textEdit.setTextColor(black)
                        dialog.textEdit.append(str(early).split()[0] + " is a fixed holiday")
                        break
            if flag == 0:
                wkg_count += 1
            if inclusive_end == 0:
                if early == late - timedelta(days=1):
                    break
            else:
                if early == late:
                    break
            early = early + timedelta(days=1)
        return wkg_count

    else:
        if inclusive_start == 1 and inclusive_end == 1:
            return len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(1900,1,1)).between(early,late,True))
        elif inclusive_start == 1:
            return len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(1900,1,1)).between(early,late - timedelta(days=1),True))
        elif inclusive_end == 1:
            return len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(1900,1,1)).between(early + timedelta(days=1),late,True))
        else:
            return len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(1900,1,1)).between(early,late,False))

def getWorkingDays(start_date,numdays,fixed_rules,variable_rules,variable_ext,gf,em,grange,adding,dialog):
    grand_total = 0
    while 1:
        flag = 0
        dialog.textEdit.setTextColor(grey)
        dialog.textEdit.append("Working On: " + str(start_date).split()[0])
        if len(rrule(DAILY,byweekday=(SA,SU),dtstart=start_date).between(start_date,start_date,True)) == 1:
            flag = 1
            dialog.textEdit.setTextColor(black)
            dialog.textEdit.append(str(start_date).split()[0] + " is on a weekend")
        if len(fixed_rules) > 0 and (flag == 0):
            for i in fixed_rules:
                if len(rrule(YEARLY,bymonth=i[1],bymonthday=i[0],byweekday=(MO,TU,WE,TH,FR),dtstart=start_date).between(start_date,start_date,True)) == 1:
                    flag = 1
                    dialog.textEdit.setTextColor(black)
                    dialog.textEdit.append(str(start_date).split()[0] + " is a fixed date holiday")
                    break
        if len(variable_rules) > 0 and (flag == 0):
            for i in variable_rules:
                print i
                if len(rrule(YEARLY,bymonth=i[2],byweekday=i[1](rel_matrix[i[0]-1]),dtstart=start_date).between(start_date,start_date,True)) == 1:
                    flag = 1
                    dialog.textEdit.setTextColor(black)
                    dialog.textEdit.append(str(start_date).split()[0] + " is a variable date holiday")
                    break
            if len(variable_ext) > 0 and (flag == 0):
                for i in variable_ext:
                    if len(rrule(YEARLY,byyearday=(i[1][0],i[1][1],i[1][2],i[1][3],i[1][4],i[1][5],i[1][6]),byweekday=i[0],dtstart=start_date).between(start_date,start_date,True)) == 1:
                        flag = 1
                        dialog.textEdit.setTextColor(black)
                        dialog.textEdit.append(str(start_date).split()[0] + " is a variable date holiday")
                        break
        if gf == 1 and (flag == 0):
            tempdate = str(start_date)
            currentyear = int(tempdate.split('-')[0])
            if tempdate.split()[0] == str(easter(currentyear) + timedelta(days=-2)):
                flag = 1
                dialog.textEdit.setTextColor(black)
                dialog.textEdit.append(str(start_date).split()[0] + " is Good Friday")
        if em == 1 and (flag == 0):
            tempdate = str(start_date)
            currentyear = int(tempdate.split('-')[0])
            if tempdate.split()[0] == str(easter(currentyear) + timedelta(days=1)):
                flag = 1
                dialog.textEdit.setTextColor(black)
                dialog.textEdit.append(str(start_date).split()[0] + " is Easter Monday")
        if len(grange) > 0 and (flag == 0):
            for i in grange:
                if len(rrule(YEARLY,bymonth=i[1],bymonthday=i[0],byweekday=(MO,TU,WE,TH,FR),dtstart=start_date).between(start_date,start_date,True)) == 1:
                    flag = 1
                    dialog.textEdit.setTextColor(black)
                    dialog.textEdit.append(str(start_date).split()[0] + " is a fixed date holiday")
                    break
        if flag == 0:
            grand_total += 1
        if grand_total == numdays:
            break
        print "grand_total: " + str(grand_total)
        if adding == 1:
            start_date = start_date + timedelta(days=1)
        else:
            start_date = start_date - timedelta(days=1)
    return (start_date)

def addDays(early,numdays,fixed_rules,variable_rules,variable_ext,gf,em,grange,dialog,working=0,inclusive_days=0):
    print "start: " + str(early)
    print "numdays: " + str(numdays)
    print "inclusive: " + str(inclusive_days)
    dialog.textEdit.clear()
    if working == 1:
        if inclusive_days == 0:
            early = early + timedelta(days=1)
        result = getWorkingDays(early,numdays,fixed_rules,variable_rules,variable_ext,gf,em,grange,1,dialog)
        return result.date()

    else:
        if inclusive_days == 1:
            early = early - timedelta(days=1)
            print early
        result = early + timedelta(days=numdays)
        print result
        return result.date()

def subDays(late,numdays,fixed_rules,variable_rules,variable_ext,gf,em,grange,dialog,working=0,inclusive_days=0):
    print "numdays: " + str(numdays)
    dialog.textEdit.clear()
    if working == 1:
        if inclusive_days == 0:
            late = late - timedelta(days=1)
        result = getWorkingDays(late,numdays,fixed_rules,variable_rules,variable_ext,gf,em,grange,0,dialog)
        return result.date()

    else:
        if inclusive_days == 1:
            late = late + timedelta(days=1)
        result = late - timedelta(days=numdays)
        return result.date()